Imports System.Net.NetworkInformation

Class SudoInterface
    Inherits NetworkInterface
#Region "Fields"

    Private ReadOnly _desc As String
    Private ReadOnly _id As String
    Private ReadOnly _name As String

#End Region

#Region "Properties"

    Public Overrides ReadOnly Property Description() As String
        Get
            Return _desc
        End Get
    End Property

    Public Overrides ReadOnly Property Id() As String
        Get
            Return _id
        End Get
    End Property

    Public Overrides ReadOnly Property IsReceiveOnly() As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property Name() As String
        Get
            Return _name
        End Get
    End Property

    Public Overrides ReadOnly Property NetworkInterfaceType() As NetworkInterfaceType
        Get
            Return NetworkInterfaceType.Wireless80211
        End Get
    End Property

    Public Overrides ReadOnly Property OperationalStatus() As OperationalStatus
        Get
            Return OperationalStatus.Up
        End Get
    End Property

    Public Overrides ReadOnly Property Speed() As Long
        Get
            Return 0
        End Get
    End Property

    Public Overrides ReadOnly Property SupportsMulticast() As Boolean
        Get
            Return False
        End Get
    End Property

#End Region

#Region "Constructors"

    Public Sub New(ByVal wlan As WlanInterface)
        _id = wlan.InterfaceGuid.ToString()
        _desc = wlan.InterfaceDescription
    End Sub

    Public Sub New(ByVal id As String, ByVal description As String, ByVal name As String)
        _id = id
        _name = name
        _desc = description
    End Sub

#End Region

#Region "Public Methods"

    Public Overrides Function GetIPProperties() As IPInterfaceProperties
        Return Nothing
    End Function

    Public Overrides Function GetIPv4Statistics() As IPv4InterfaceStatistics
        Throw New NotImplementedException()
    End Function

    Public Overrides Function GetPhysicalAddress() As PhysicalAddress
        Return PhysicalAddress.None
    End Function

    Public Overrides Function Supports(ByVal networkInterfaceComponent As NetworkInterfaceComponent) As Boolean
        Return True
    End Function

#End Region
End Class

